Bug 914924 - Review Request: nodejs-oauth - Library for interacting with OAuth 1.0, 1.0A, 2 and Echo
Summary: Review Request: nodejs-oauth - Library for interacting with OAuth 1.0, 1.0A, ...
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Jamie Nguyen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
: 914923 (view as bug list)
Depends On:
Blocks: 914926
TreeView+ depends on / blocked
 
Reported: 2013-02-23 13:13 UTC by Tom Hughes
Modified: 2013-04-07 00:38 UTC (History)
3 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2013-04-07 00:38:24 UTC
jamielinux: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Tom Hughes 2013-02-23 13:13:04 UTC
Spec URL: http://download.compton.nu/nodejs/nodejs-oauth.spec
SRPM URL: http://download.compton.nu/nodejs/nodejs-oauth-0.9.8-1.fc18.src.rpm
Fedora Account System Username: tomh

Description:
Library for interacting with OAuth 1.0, 1.0A, 2 and Echo. Provides
simplified client access and allows for construction of more complex
apis and OAuth providers.

Comment 1 Tom Hughes 2013-02-23 13:16:13 UTC
*** Bug 914923 has been marked as a duplicate of this bug. ***

Comment 2 Jamie Nguyen 2013-03-02 14:34:02 UTC
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
[!]: Package contains no bundled libraries.

lib/sha1.js is BSD licensed, but also it's copied from jshash:
http://pajhome.org.uk/crypt/md5/scripts.html


[!]: %check is present and all tests pass.

Needs something like this so that "require('vows')" works (but tests pass otherwise):
  %check
  cp -pr %{nodejs_sitelib} .


[!]: nodejs-oauth.noarch: W: spelling-error %description -l en_US apis -> pis, apish, apes

apis should probably be APIs.



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[-]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[!]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 30720 bytes in 7 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[!]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (oauth-0.9.8.tgz)
[x]: SourceX is a working URL.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: nodejs-oauth-0.9.8-1.fc18.noarch.rpm
          nodejs-oauth-0.9.8-1.fc18.src.rpm
nodejs-oauth.noarch: W: spelling-error %description -l en_US apis -> pis, apish, apes
nodejs-oauth.noarch: W: only-non-binary-in-usr-lib
nodejs-oauth.src: W: spelling-error %description -l en_US apis -> pis, apish, apes
2 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint nodejs-oauth
nodejs-oauth.noarch: W: spelling-error %description -l en_US apis -> pis, apish, apes
nodejs-oauth.noarch: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 2 warnings.
# echo 'rpmlint-done:'



Requires
--------
nodejs-oauth-0.9.8-1.fc18.noarch.rpm (rpmlib, GLIBC filtered):
    
    nodejs(engine)



Provides
--------
nodejs-oauth-0.9.8-1.fc18.noarch.rpm:
    
    nodejs-oauth = 0.9.8-1.fc18
    npm(oauth) = 0.9.8



MD5-sum check
-------------
http://registry.npmjs.org/oauth/-/oauth-0.9.8.tgz :
  CHECKSUM(SHA256) this package     : dbff4da9078d6316474e3b6d2fe8c2c78c5b1713707692e19e39546ba4bbd84b
  CHECKSUM(SHA256) upstream package : dbff4da9078d6316474e3b6d2fe8c2c78c5b1713707692e19e39546ba4bbd84b


Generated by fedora-review 0.3.1 (b71abc1) last change: 2012-10-16
Buildroot used: fedora-18-x86_64
Command line :/bin/fedora-review --rpm-spec -n nodejs-oauth-0.9.8-1.fc18.src.rpm

Comment 3 Tom Hughes 2013-03-02 15:18:43 UTC
Can you explain the logic behind the copying thing? I know you were doing that but my tests seemed to show that it wasn't necessary because node would find them anyway on account of /usr/lib/node_modules being on the default search path?

Comment 4 Jamie Nguyen 2013-03-02 15:21:55 UTC
When I build the packages in mock with check enabled they always seem to fail without a workaround (eg, copying nodejs_sitelib). Does it work for you in mock? I can't think what might be different between our setups.

Comment 5 Tom Hughes 2013-03-02 15:49:02 UTC
You seem to be right.. I have no idea how it is working for me outside of mock then ;-)

Comment 6 Tom Hughes 2013-03-03 16:49:26 UTC
License updated, tests fixed and description adjusted:

Spec URL: http://download.compton.nu/nodejs/nodejs-oauth.spec
SRPM URL: http://download.compton.nu/nodejs/nodejs-oauth-0.9.8-2.fc18.src.rpm

As far as the copying goes, one option is to remove that code and use the jshashes npm instead - except it turns out that has copied the code from the same place...

I think I'm going to send a mail to the packaging list to try and get some general guidance on this question of when copy'n'paste becomes bundling.

Comment 7 Tom Hughes 2013-03-09 14:56:03 UTC
I've opened a review ticket for nodejs-jshashes (#919689) but it seems likely that I will have to seek a bundling exemption. I think there is a good case for that however.

Update spec and srpm utilising nodejs-jshashes in place of the bundled sha1.js:

Spec URL: http://download.compton.nu/nodejs/nodejs-oauth.spec
SRPM URL: http://download.compton.nu/nodejs/nodejs-oauth-0.9.8-3.fc18.src.rpm

Comment 8 Tom Hughes 2013-03-10 19:09:01 UTC
So after all that I have now realised that the bundled sha1.js is never actually used on Fedora because it prefers to use the crypto module to compute the has if node has been built against openssl as the Fedora one has. So we can just remove it and patch out the fallback code:

Spec URL: http://download.compton.nu/nodejs/nodejs-oauth.spec
SRPM URL: http://download.compton.nu/nodejs/nodejs-oauth-0.9.8-4.fc18.src.rpm

Comment 9 Jamie Nguyen 2013-03-10 20:22:59 UTC
Awesome!


Issues:
=======

[!]: Latest version is packaged.

0.9.10 released just a few days ago. This is the only issue though, and all tests pass with both 0.9.8 and 0.9.10.


Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[-]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 30720 bytes in 7 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: nodejs-oauth-0.9.8-4.fc18.noarch.rpm
nodejs-oauth.noarch: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint nodejs-oauth
nodejs-oauth.noarch: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'



Requires
--------
nodejs-oauth (rpmlib, GLIBC filtered):
    nodejs(engine)



Provides
--------
nodejs-oauth:
    nodejs-oauth
    npm(oauth)



MD5-sum check
-------------
http://registry.npmjs.org/oauth/-/oauth-0.9.8.tgz :
  CHECKSUM(SHA256) this package     : dbff4da9078d6316474e3b6d2fe8c2c78c5b1713707692e19e39546ba4bbd84b
  CHECKSUM(SHA256) upstream package : dbff4da9078d6316474e3b6d2fe8c2c78c5b1713707692e19e39546ba4bbd84b


Generated by fedora-review 0.4.0 (660ce56) last change: 2013-01-29
Buildroot used: fedora-18-x86_64
Command line :/bin/fedora-review --rpm-spec -n nodejs-oauth-0.9.8-4.fc18.src.rpm

Comment 11 Jamie Nguyen 2013-03-10 20:29:25 UTC
Sweet. Package approved!

Comment 12 Tom Hughes 2013-03-10 20:31:36 UTC
New Package SCM Request
=======================
Package Name: nodejs-oauth
Short Description: Library for interacting with OAuth 1.0, 1.0A, 2 and Echo
Owners: tomh
Branches: f18
InitialCC:

Comment 13 Gwyn Ciesla 2013-03-11 12:21:01 UTC
Git done (by process-git-requests).

Comment 14 Fedora Update System 2013-03-11 13:49:24 UTC
nodejs-xml2js-0.2.6-2.fc18, nodejs-srs-0.2.20-1.fc18, nodejs-sqlite3-2.1.5-3.fc18, nodejs-zipfile-0.3.4-2.fc18, nodejs-millstone-0.5.15-1.fc18, nodejs-oauth-0.9.10-1.fc18, nodejs-chrono-1.0.4-1.fc18, nodejs-sphericalmercator-1.0.2-1.fc18, nodejs-mapnik-reference-5.0.4-2.fc18, nodejs-passport-0.1.16-1.fc18, nodejs-step-0.0.5-1.fc18, nodejs-zap-0.2.5-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/FEDORA-2013-3075/nodejs-millstone-0.5.15-1.fc18,nodejs-oauth-0.9.10-1.fc18,nodejs-srs-0.2.20-1.fc18,nodejs-sqlite3-2.1.5-3.fc18,nodejs-zipfile-0.3.4-2.fc18,nodejs-xml2js-0.2.6-2.fc18,nodejs-zap-0.2.5-2.fc18,nodejs-step-0.0.5-1.fc18,nodejs-passport-0.1.16-1.fc18,nodejs-sphericalmercator-1.0.2-1.fc18,nodejs-mapnik-reference-5.0.4-2.fc18,nodejs-chrono-1.0.4-1.fc18

Comment 15 Fedora Update System 2013-03-12 08:30:16 UTC
nodejs-xml2js-0.2.6-2.fc18, nodejs-srs-0.2.20-1.fc18, nodejs-sqlite3-2.1.5-3.fc18, nodejs-zipfile-0.3.4-2.fc18, nodejs-millstone-0.5.15-1.fc18, nodejs-oauth-0.9.10-1.fc18, nodejs-chrono-1.0.4-1.fc18, nodejs-sphericalmercator-1.0.2-1.fc18, nodejs-mapnik-reference-5.0.4-2.fc18, nodejs-passport-0.1.16-1.fc18, nodejs-step-0.0.5-1.fc18, nodejs-zap-0.2.5-2.fc18 has been pushed to the Fedora 18 testing repository.

Comment 16 Fedora Update System 2013-03-12 23:29:01 UTC
nodejs-xml2js-0.2.6-2.fc18, nodejs-srs-0.2.20-1.fc18, nodejs-sqlite3-2.1.5-3.fc18, nodejs-zipfile-0.3.4-2.fc18, nodejs-millstone-0.5.15-1.fc18, nodejs-oauth-0.9.10-1.fc18, carto-0.9.4-1.fc18, nodejs-passport-oauth-0.1.14-3.fc18, nodejs-chrono-1.0.4-1.fc18, nodejs-sphericalmercator-1.0.2-1.fc18, nodejs-mapnik-reference-5.0.4-2.fc18, nodejs-passport-0.1.16-1.fc18, nodejs-step-0.0.5-1.fc18, nodejs-zap-0.2.5-2.fc18 has been pushed to the Fedora 18 testing repository.

Comment 17 Fedora Update System 2013-03-15 00:05:35 UTC
nodejs-xml2js-0.2.6-2.fc18, nodejs-oauth-0.9.10-1.fc18, carto-0.9.4-1.fc18, nodejs-passport-oauth-0.1.14-3.fc18, nodejs-millstone-0.5.15-2.fc18, nodejs-srs-0.2.20-2.fc18, nodejs-sqlite3-2.1.5-4.fc18, nodejs-zipfile-0.3.4-3.fc18, nodejs-chrono-1.0.4-1.fc18, nodejs-sphericalmercator-1.0.2-1.fc18, nodejs-mapnik-reference-5.0.4-2.fc18, nodejs-passport-0.1.16-1.fc18, nodejs-step-0.0.5-1.fc18, nodejs-zap-0.2.5-2.fc18 has been pushed to the Fedora 18 testing repository.

Comment 18 Fedora Update System 2013-04-07 00:38:27 UTC
nodejs-xml2js-0.2.6-2.fc18, nodejs-oauth-0.9.10-1.fc18, carto-0.9.4-1.fc18, nodejs-passport-oauth-0.1.14-3.fc18, nodejs-millstone-0.5.15-2.fc18, nodejs-srs-0.2.20-2.fc18, nodejs-sqlite3-2.1.5-4.fc18, nodejs-zipfile-0.3.4-3.fc18, nodejs-chrono-1.0.4-1.fc18, nodejs-sphericalmercator-1.0.2-1.fc18, nodejs-mapnik-reference-5.0.4-2.fc18, nodejs-passport-0.1.16-1.fc18, nodejs-step-0.0.5-1.fc18, nodejs-zap-0.2.5-2.fc18 has been pushed to the Fedora 18 stable repository.


Note You need to log in before you can comment on or make changes to this bug.